#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

streamopen(name param dir)
{
	defstream $(name) $param basic $dir;
	global $(name)_dir    = $dir
		   $(name)_cooked = true;
}

streamclose(name)
{
	remove GLOBALS $(name)_dir
	remove GLOBALS $(name)_cooked
	rmstream $name
}

ioctl(name ctlstr)
{
	switch $ctlstr
		when eq($^ cooked)
			set $(name)_cooked = true
			breaksw
		when eq($^ raw)
			set $(name)_cooked = ''
			breaksw
		when eq($^ ?cooked)
			return(cond($(name)_cooked cooked raw))
			breaksw
		when eq($^ flush)
			return(ioctl($name flush))
			breaksw
		when match($^ flowctl=*)
			return(ioctl($name $ctlstr))
			breaksw
		case *
			return(not-implemented)
	endsw
}


rewind(name)
{
	rewind $name
}

getpos(name)
{
	return(getpos($name))
}

setpos(name pos)
{
	setpos $name $pos
}
