#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	table identity +get(ARGV 1)
	onerror error-handler
	read
	defstream mailer "pipe:///usr/sbin/sendmail get(identity email)" basic true;
	export stream mailer mailer
	defstream mailbody 'dup://mailer' html true;
	outstream mailer
	if check(identity myemail)
		write "From: get(identity myemail)\n"
	endif
	write "To: get(identity email)\n"
	write "MIME-Version: 1.0\n"
	write "Content-Type: text/plain; charset=\"get(identity newscharset)\"\n"
	write "Subject: pending for approval\n"
	write \n
	write --process\n
	outstream mailbody
	writetag ARTICLE;
	write \n
	writetag TITLE; write \n
		write ': '
		if tag(email)
			writetag A HREF "mailto\:trim(tag(email))";
			write cond(tag(name) tag(name) anonymous)
			writetag /A;
		else
			write cond(tag(name) tag(name) anonymous)
		endif
		writetag BR; write \n
		write ": tag(subject)\n"
	writetag /TITLE; write \n
	writetag BODY; write \n
		write tag(text)\n
	writetag /BODY;
	outstream stdout
	write "Location: get(identity onsuccess)"
	write ''
	exit
}

error-handler
{
	writeto stdout "Location: get(identity onfailure)"
	writeto stdout ''
	exit
}
