.do
{
	if isexport(proc sys:getopt)
		import proc getopt sys:getopt
	else
		def tmp = subload(* getopt);
		import proc getopt sys:getopt
		release subint $tmp
	endif
}
# getopt(opt-storage callback [extra])
# opt-storage has the following structure:
# 	opt-name <null>  -- an option without arguments
#	opt-name :		 -- an option with a compulsory argument
#	opt-name =opt-name2 -- redirect to opt-name2
# callback is called with 3 arguments:
# - type: 'option', 'name' or 'unknown'
# - option-name or filename
# - argument if present
# - extra passed to getopt

