#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	table src +get(ARGV 1)
	def state = get(ARGV 2);
	if not($state) set state = 1 endif
	global prev iter cpl tmp ch maxstate = add($state 1) i;
	defautoseq escape escape 
	array states
	insert states 0 $state
	write ['.start $state;\n.final $state;\n\n']
	foreach iter src
		set cpl = length(commonprefix($prev $iter))
		set tmp = substr($iter $cpl)
		while $tmp
			set ch = substr($tmp 0 1)
			set tmp = substr($tmp 1)
			write "get(states $cpl); \$\$ = ascii($ch); 1; $maxstate; '{}{}'\n"
			incr cpl 1
			put-or-insert(states $cpl $maxstate)
			incr maxstate 1
		loop
		write "get(states $cpl); !\$\$; 1; 1; '{"'translate(reset(escape) get(src $iter))'"}{}\n'"
		set prev = $iter
	loop
	set i = $state
	while less(int $i $maxstate)
		write "$i; ^1; 1; $maxstate; '{}{}'\n"
		incr i 1
	loop
	write "$maxstate; !\$\$; 1; 1; \{ \"<unmatched>\" \}\{\}\n"
	write "$maxstate; 1; 1; 1; \{\}\{\}\n"
	exit
}

put-or-insert(sto key val)
{
 	if check($sto $key)
		put $sto $key $val
	else
		insert $sto $key $val
	endif
}
