#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	table fontlist !fontlist;
	if instream()
		rmstream instream()
	endif
	subload u8h utf8html
	defstream ins u8h?trim(readline('Input file:')) script;
	instream ins
	global current_font;
	global counter;
	global line_counter = 0;
}

tag "FONT"
{
	if tag(FACE)
		def name;
		split $[FACE] ',' '' name;
		set name = trim($name)
		if not($name) return endif
		if not(check(fontlist $name))
			insert fontlist $name 0
		endif
		push(current_font = $name)
	else
		push(current_font = $current_font)
	endif
		push(counter = 0)
}

tag "/FONT" { 
				if $current_font
					echo "$current_font $counter"
					put fontlist $current_font add($counter get(fontlist $current_font))
					pop counter
				endif
				pop current_font 
			}

tag "BR" { echo postincr(line_counter 1) }

tag "P" { echo postincr(line_counter 1) }

tag "&"
{
	if $current_font
		incr counter 1
	endif
}

char "?" { 
	if $current_font
		incr counter 1
	endif
}

