#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

HTML(;)
{
	writetag HTML;
	write \n
}

-HTML(;)
{
	writetag /HTML;
	write \n
}

HEAD(;)
{
	writetag HEAD;
	write \n
}

-HEAD(;)
{
	writetag /HTML;
	write \n
}

TITLE(title)
{
	writetag TITLE;
	write $title
	writetag /TITLE;
	write \n
}

META(name content)
{
	writetag META NAME $name CONTENT $content;
	write \n
}

META-HTTP(http content)
{
	writetag META HTTP-EQUIV $http CONTENT $content;
	write \n
}

BODY(;...)
{
	writetag BODY passargs(1);
	write \n
}


-BODY(;)
{
	writetag /BODY;
	write \n
}

P(;...)
{
	writetag P passargs(1);
	write \n
}

BR(;)
{
	writetag BR;
	write \n
}

FORM(action method ...)
{
	writetag FORM ACTION $action METHOD $method passargs(3);
	write \n
}

-FORM(;)
{
	writetag /FORM;
	write \n
}

INPUT-TEXT(name; ...)
{
	writetag INPUT TYPE TEXT NAME $name passargs(2);
	write \n
}

INPUT-PASSWORD(name; ...)
{
	writetag INPUT TYPE PASSWORD NAME $name passargs(2);
	write \n
}

SUBMIT(label; ...)
{
	writetag INPUT TYPE SUBMIT VALUE $label passargs(2);
	write \n
}

HIDDEN(name value; ...)
{
	writetag INPUT TYPE HIDDEN NAME $name VALUE $value passargs(3);
	write \n
}

TABLE(;...)
{
	writetag TABLE passargs(1);
	write \n
}

-TABLE(;)
{
	writetag /TABLE;
	write \n
}

TR(;)
{
	writetag TR;
	write \n
}

TD(;)
{
	writetag TD;
	write \n
}
