#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.module <files>
.pool diversion

main
{
	table identity +get(ARGV 1)
	def questions = get(identity news)'.0'get(identity newsext)
		result = get(identity news).0.t;
	global qno = 0 ansno;
	mail-prev-results()
	shared title question;
	defstream ins $questions html;
	defstream out get(identity hotnews) basic true;
	shift-news-files(get(identity news) .t get(identity newsmax))
	table voting !$result
	instream ins
}

mail-prev-results()
{
	if(and(exists(get(identity news).0.t) check(identity email)))
		defstream mailer "pipe:///usr/sbin/sendmail get(identity email)" basic true
		local table(prevoting get(identity news).0.t)
		writeto mailer "To: get(identity email)\n"
		if check(identity myemail)
			writeto mailer "From: get(identity myemail)\n"
		endif
		writeto mailer "Subject: voting results\n"
		writeto mailer "\n"
		def iter ansno qno;
		writeto mailer get(prevoting title)\n
		foreach iter prevoting
			if not(isprefix($iter '#')) break endif
			if issuffix($iter .r) continue endif
			split($iter '.' '' qno ansno)
			if not($ansno)
				writeto mailer \nget(prevoting $iter)\n
			else
				writeto mailer \tget(prevoting $iter)\n
				if eq($ansno other)
					set iter = get(prevoting $iter\.r)
					while $iter
						set iter = split($iter '\f' '' ansno)
						writeto mailer \t\t$ansno\n
					loop
				else
					writeto mailer \t\tget(prevoting $iter\.r)\n
				endif
			endif
		loop
		writeto mailer "\nTotal: get(prevoting total)\n\n"
		rmstream mailer
	endif
}

atexit
{
	insert voting count $qno
	insert voting total 0
	def iter item qtitle qno ansno output;
	set question = ''
	foreach iter voting
		if not(isprefix($iter '#')) break endif
		if issuffix($iter .r) continue endif 
		split($iter '.' '' qno ansno)
		if not($ansno)
			if $question
				set output = $(output)make-subst(newsitem $qtitle $question)
			endif
			set question = ''
			set qtitle = get(voting $iter)
		else
			if eq(other $ansno)
				set item = "<input type=text name=\"dec($qno).other\">"
			elsif eq(int 1 $ansno)
				set item = "<input type=radio name=\"dec($qno)\" value=1 checked>"
			else
				set item = "<input type=radio name=\"dec($qno)\" value=\"dec($ansno)\">"
			endif
			set question = $(question)substit(get(identity newssubitem) % $item\ get(voting $iter) first)
		endif
	loop
	if $question
		set output = $(output)make-subst(newsitem $qtitle $question)
	endif
	writeto out make-subst(newsheader get(voting title) $output)
}

make-subst(src title text)
{
	return(substit(substit(get(identity $src) %% $title) % $text))
}

tag "TITLE"
{
	prefix 'title:'
	defstream divert 'inline://diversion/title' html true
}

tag "QUESTION"
{
	incr qno 1
	set ansno = 1
	prefix 'question:'
	defstream divert 'inline://diversion/question' html true
}

tag "title:/TITLE"
{
	release stream divert
	insert voting title $title
	prefix ''
	clear title
}

tag "title:P"
{
	writeto divert \n;
	writetagto divert P;
	writeto divert \n;
}

tag "title:&"
{
	writetagto divert;
}

char "title:?"
{
	writetagto divert;
}


tag "question:ANSWER"
{
	if tag(other)
		insert voting int($qno).other tag(value)
		insert voting int($qno).other.r ''
	else
		insert voting int($qno)\.int($ansno) tag(value)
		insert voting int($qno)\.int($ansno).r ''
		incr ansno 1
	endif
}

tag "question:/QUESTION"
{
	release stream divert
	insert voting int($qno) $question
	prefix ''
	clear question
}

tag "question:P"
{
	writeto divert \n
	writetagto divert P;
	writeto divert \n
}

tag "question:&"
{
	writetagto divert;
}

char "question:?"
{
	writetagto divert;
}

shift-news-files(newsfile newsext newsmax)
{
	def i = $newsmax;
	while neq(int $i 0)
		if exists($newsfile\.sub($i 1)$newsext)
			mvfile $newsfile\.sub($i 1)$newsext $newsfile\.$i$newsext
		endif
		decr i 1
	loop
	rmfile $newsfile\.$newsmax$newsext
}
