#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

xtranslate(as string hooks extra='')
{
	def out tmp curch pending stname;
	while $string;
		set curch = substr($string 0 1)
		set tmp = ctranslate($as ascii($curch))
		if not($tmp)
			if check($hooks .rejected.)
				call get($hooks .rejected.) $as $curch $extra;
			endif
			set pending = ''
			break
		endif
		if not($pending)
			set stname = statename($as '')
			if not($stname)
				set stname = state($as)
			endif
			if check($hooks $stname)
				call get($hooks $stname) $as $curch $extra;
			endif
		endif
		if eq('+' substr($tmp 0 1))
			set string = substr($string 1)
			set pending = ''
		else
			set pending = true
		endif
		set tmp = substr($tmp 1)
		if ge(int $tmp 256)
			if check($hooks .outofrange.)
				call get($hooks .outofrange.) $as $curch $extra;
			endif
		else
			set out = $(out)char($tmp)
		endif
	loop;
	if $pending
		if check($hooks .pending.)
			call get($hooks .pending.) $as $curch $extra;
		endif
	endif
	return($out)
}
